## zint 2.15.0

=== CMakeLists.txt ===
# Copyright (C) 2008 by BogDan Vatra < bogdan@licentia.eu >
# Copyright (C) 2009-2025 Robin Stuart <rstuart114@gmail.com>
# vim: set ts=4 sw=4 et :

cmake_minimum_required(VERSION 3.10)
project(zint-package)

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(ZINT_VERSION_MAJOR 2)
set(ZINT_VERSION_MINOR 15)
set(ZINT_VERSION_RELEASE 0)
set(ZINT_VERSION_BUILD 0) # Set to 0 before release, set to 9 after release
set(ZINT_VERSION "${ZINT_VERSION_MAJOR}.${ZINT_VERSION_MINOR}.${ZINT_VERSION_RELEASE}.${ZINT_VERSION_BUILD}")

add_definitions(-DZINT_VERSION=\"${ZINT_VERSION}\")

option(ZINT_DEBUG     "Set debug compile flags"         OFF)
option(ZINT_NOOPT     "Set no optimize compile flags"   OFF)
option(ZINT_SANITIZE  "Set sanitize address/undefined"  OFF)
option(ZINT_SANITIZEM "Set sanitize memory (ignored if ZINT_SANITIZE)" OFF)
option(ZINT_TEST      "Set test compile flag"           OFF)
option(ZINT_COVERAGE  "Set code coverage flags"         OFF)
option(ZINT_SHARED    "Build shared library"            ON)
option(ZINT_STATIC    "Build static library"            OFF)
option(ZINT_USE_PNG   "Build with PNG support"          ON)
option(ZINT_USE_QT    "Build with Qt support"           ON)
option(ZINT_QT6       "If ZINT_USE_QT, use Qt6"         OFF)
option(ZINT_UNINSTALL "Add uninstall target"            ON)
option(ZINT_FRONTEND  "Build frontend"                  ON)

if(NOT ZINT_SHARED AND NOT ZINT_STATIC)
    message(SEND_ERROR "Either ZINT_SHARED or ZINT_STATIC or both must be set")
endif()

include(GNUInstallDirs)
# Taken from old (2008) KDE "SetPaths.cmake"
# Set a default build type for single-configuration CMake generators if no build type is set
if(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif()

include(CheckCCompilerFlag)
include(CheckFunctionExists)

if(NOT MSVC) # Use default warnings if MSVC otherwise inundated
    check_c_compiler_flag("-Wall" C_COMPILER_FLAG_WALL)
    if(C_COMPILER_FLAG_WALL)
        add_compile_options("-Wall")
    endif()

    check_c_compiler_flag("-Wextra" C_COMPILER_FLAG_WEXTRA)
    if(C_COMPILER_FLAG_WEXTRA)
        add_compile_options("-Wextra")
    endif()

    check_c_compiler_flag("-Wpedantic" C_COMPILER_FLAG_WPEDANTIC)
    if(C_COMPILER_FLAG_WPEDANTIC)
        add_compile_options("-Wpedantic")
    endif()

    check_c_compiler_flag("-Wcast-align" C_COMPILER_FLAG_WCASTALIGN)
    if(C_COMPILER_FLAG_WCASTALIGN)
        add_compile_options("-Wcast-align")
    endif()
    check_c_compiler_flag("-Wpointer-arith" C_COMPILER_FLAG_WPOINTERARITH)
    if(C_COMPILER_FLAG_WPOINTERARITH)
        add_compile_options("-Wpointer-arith")
    endif()
    check_c_compiler_flag("-Wshadow" C_COMPILER_FLAG_WSHADOW)
    if(C_COMPILER_FLAG_WSHADOW)
        add_compile_options("-Wshadow")
    endif()
    check_c_compiler_flag("-Wundef" C_COMPILER_FLAG_WUNDEF)
    if(C_COMPILER_FLAG_WUNDEF)
        add_compile_options("-Wundef")
    endif()
    check_c_compiler_flag("-Wwrite-strings" C_COMPILER_FLAG_WWRITESTRINGS)
    if(C_COMPILER_FLAG_WWRITESTRINGS)
        add_compile_options("-Wwrite-strings")
    endif()
endif()

if(ZINT_DEBUG)
    check_c_compiler_flag("-g" C_COMPILER_FLAG_G)
    if(C_COMPILER_FLAG_G)
        add_compile_options("-g")
    endif()
endif()

if(ZINT_NOOPT)
    check_c_compiler_flag("-O0" C_COMPILER_FLAG_O0)
    if(C_COMPILER_FLAG_O0)
        add_compile_options("-O0")
    endif()
endif()

if(ZINT_SANITIZE)
    if(MSVC)
        if(MSVC_VERSION GREATER_EQUAL 1920)
            add_compile_options(-fsanitize=address)
            message(STATUS "ZINT_SANITIZE: setting -fsanitize=address for MSVC 2019")
        else()
            message(STATUS "ZINT_SANITIZE: ignoring for MSVC < 2019")
        endif()
    else()
        set(SANITIZERS address undefined leak)
        foreach(sanitizer IN ITEMS ${SANITIZERS})
            set(CMAKE_REQUIRED_LIBRARIES -fsanitize=${sanitizer})
            check_c_compiler_flag(-fsanitize=${sanitizer} C_COMPILER_FLAG_FSANITIZE_${sanitizer})
            if(C_COMPILER_FLAG_FSANITIZE_${sanitizer})
                add_compile_options(-fsanitize=${sanitizer})
                link_libraries(-fsanitize=${sanitizer})
            endif()
            unset(CMAKE_REQUIRED_LIBRARIES)
        endforeach()

        if(CMAKE_C_COMPILER_ID MATCHES "Clang")
            # Recent clangs added deprecation warnings for `sprintf()` that are only triggered on sanitize - suppress
            add_compile_options(-Wno-deprecated-declarations)
        endif()
    endif()
endif()

if(ZINT_TEST)
    enable_testing()
endif()

if(ZINT_COVERAGE)
    set(CMAKE_REQUIRED_LIBRARIES -fprofile-arcs)
    check_c_compiler_flag(--coverage C_COMPILER_FLAG_COVERAGE)
    unset(CMAKE_REQUIRED_LIBRARIES)
    if(C_COMPILER_FLAG_COVERAGE)
        add_compile_options(--coverage)
        link_libraries(-fprofile-arcs)

        check_c_compiler_flag(-O0 C_COMPILER_FLAG_O0)
        if(C_COMPILER_FLAG_O0)
            add_compile_options(-O0)
        endif()
    endif()
endif()

check_function_exists(getopt_long_only HAVE_GETOPT_LONG_ONLY)
if(NOT HAVE_GETOPT_LONG_ONLY)
    add_subdirectory(getopt)
endif()

add_subdirectory(backend)
if(ZINT_FRONTEND)
    add_subdirectory(frontend)
endif()

if(NOT ZINT_USE_QT)
    message(STATUS "Qt support was disabled for this build")
elseif(ZINT_QT6 OR ($ENV{CMAKE_PREFIX_PATH} MATCHES "6[.][0-9][.][0-9]"))
    set(USE_QT6 TRUE)
    message(STATUS "Using Qt6")
    cmake_policy(SET CMP0012 NEW) # Recognize constants in if()
    cmake_policy(SET CMP0072 NEW) # Choose OpenGL over legacy GL
    find_package(Qt6Widgets)
    find_package(Qt6Gui)
    find_package(Qt6UiTools)
    find_package(Qt6Svg)

    if(Qt6Widgets_FOUND AND Qt6Gui_FOUND AND Qt6UiTools_FOUND AND Qt6Svg_FOUND)
        message(STATUS "Qt version: " ${Qt6Core_VERSION_MAJOR}.${Qt6Core_VERSION_MINOR}.${Qt6Core_VERSION_PATCH})
        add_subdirectory(backend_qt)
        add_subdirectory(frontend_qt)
    else()
        message(STATUS "Could NOT find Qt6")
    endif()
else()
    message(STATUS "Using Qt5")
    find_package(Qt5Widgets)
    find_package(Qt5Gui)
    find_package(Qt5UiTools)
    find_package(Qt5Svg)

    if(Qt5Widgets_FOUND AND Qt5Gui_FOUND AND Qt5UiTools_FOUND AND Qt5Svg_FOUND)
        message(STATUS "Qt version: " ${Qt5Core_VERSION_STRING})
        # Old Qt does not provide QT_VERSION_MAJOR
        if (NOT QT_VERSION_MAJOR)
            string(SUBSTRING ${Qt5Core_VERSION_STRING} 0 1 QT_VERSION_MAJOR)
        endif()
        add_subdirectory(backend_qt)
        add_subdirectory(frontend_qt)
    else()
        message(STATUS "Could NOT find Qt5")
    endif()
endif()

if(ZINT_UNINSTALL)
    configure_file(
      "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
      "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
      IMMEDIATE @ONLY)
    
    add_custom_target(uninstall
      "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
endif()

configure_file("zint-config.cmake.in" "zint-config.cmake" @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/zint-config.cmake" DESTINATION "${CMAKE_INSTALL_DATADIR}/zint")

=== backend/CMakeLists.txt ===
# Copyright (C) 2008 by BogDan Vatra < bogdan@licentia.eu >
# Copyright (C) 2009-2025 Robin Stuart <rstuart114@gmail.com>
# vim: set ts=4 sw=4 et :

cmake_minimum_required(VERSION 3.10)
project(zint)

if(ZINT_USE_PNG)
    find_package(PNG)
endif()

set(zint_COMMON_SRCS common.c eci.c filemem.c general_field.c gs1.c large.c library.c reedsol.c)
set(zint_ONEDIM_SRCS 2of5.c 2of5inter.c 2of5inter_based.c bc412.c channel.c codabar.c code.c code11.c code128.c
                     code128_based.c dxfilmedge.c medical.c plessey.c rss.c telepen.c upcean.c)
set(zint_POSTAL_SRCS auspost.c imail.c mailmark.c postal.c)
set(zint_TWODIM_SRCS aztec.c codablock.c code1.c code16k.c code49.c composite.c dmatrix.c dotcode.c gridmtx.c
                     hanxin.c maxicode.c pdf417.c qr.c ultra.c)
if(ZINT_USE_PNG AND PNG_FOUND)
    set(zint_OUTPUT_SRCS bmp.c emf.c gif.c output.c pcx.c png.c ps.c raster.c svg.c tif.c vector.c)
else()
    set(zint_OUTPUT_SRCS bmp.c emf.c gif.c output.c pcx.c ps.c raster.c svg.c tif.c vector.c)
endif()
set(zint_SRCS ${zint_OUTPUT_SRCS} ${zint_COMMON_SRCS} ${zint_ONEDIM_SRCS} ${zint_POSTAL_SRCS} ${zint_TWODIM_SRCS})

if(ZINT_SHARED)
    add_library(zint SHARED ${zint_SRCS})

    if(WIN32)
        target_sources(${PROJECT_NAME} PRIVATE libzint.rc)
    endif()
endif()

if(ZINT_STATIC)
    add_library(zint-static STATIC ${zint_SRCS})
    if(WIN32)
        set_target_properties(zint-static PROPERTIES OUTPUT_NAME zint-static)
    else()
        set_target_properties(zint-static PROPERTIES OUTPUT_NAME zint)
    endif()
endif()

function(zint_target_link_libraries library)
    if(ZINT_SHARED)
        target_link_libraries(zint ${library})
    endif()
    if(ZINT_STATIC)
        target_link_libraries(zint-static ${library})
    endif()
endfunction()

function(zint_target_compile_definitions scope definition)
    if(ZINT_SHARED)
        target_compile_definitions(zint ${scope} ${definition})
    endif()
    if(ZINT_STATIC)
        target_compile_definitions(zint-static ${scope} ${definition})
    endif()
endfunction()

function(zint_target_compile_options scope option)
    if(ZINT_SHARED)
        target_compile_options(zint ${scope} ${option})
    endif()
    if(ZINT_STATIC)
        target_compile_options(zint-static ${scope} ${option})
    endif()
endfunction()

function(zint_target_include_directories)
    if(ZINT_SHARED)
        target_include_directories(zint ${ARGN})
    endif()
    if(ZINT_STATIC)
        target_include_directories(zint-static ${ARGN})
    endif()
endfunction()

if(ZINT_SHARED)
    set_target_properties(zint PROPERTIES   SOVERSION "${ZINT_VERSION_MAJOR}.${ZINT_VERSION_MINOR}"
                                            VERSION ${ZINT_VERSION})
endif()

if(ZINT_USE_PNG AND PNG_FOUND)
    zint_target_link_libraries(PNG::PNG)
    message(STATUS "Using PNG")
else()
    zint_target_compile_definitions(PRIVATE ZINT_NO_PNG)
    message(STATUS "Not using PNG")
endif()

# Incompatible with ZINT_SANITIZE (and also with ZINT_USE_PNG unless libpng instrumented)
if(NOT ZINT_SANITIZE AND ZINT_SANITIZEM AND CMAKE_C_COMPILER_ID MATCHES "Clang")
    add_compile_options(-fsanitize=memory -fsanitize-memory-track-origins -fno-omit-frame-pointer -O2)
    link_libraries(-fsanitize=memory)
    zint_target_compile_definitions(PRIVATE ZINT_SANITIZEM)
endif()

if(ZINT_TEST)
    zint_target_compile_definitions(PUBLIC ZINT_TEST)
endif()

check_c_compiler_flag("-Wc90-c99-compat" C_COMPILER_FLAG_WC90_C99_COMPAT)
if(C_COMPILER_FLAG_WC90_C99_COMPAT)
    zint_target_compile_options(PRIVATE "-Wc90-c99-compat")
endif()

if(NOT MSVC)
    # Link with standard C math library.
    zint_target_link_libraries(m)
endif()

if(MSVC)
    if(ZINT_SHARED)
        target_compile_definitions(zint PRIVATE DLL_EXPORT)
    endif()
endif()

zint_target_include_directories(PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
)

# Adapted from old (2008) KDE "SetPaths.cmake" to use GNUInstallDirs
set(INSTALL_TARGETS_DEFAULT_ARGS RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
                                 LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
                                 ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}" COMPONENT Devel)

if(ZINT_SHARED)
    install(TARGETS zint EXPORT zint-targets ${INSTALL_TARGETS_DEFAULT_ARGS})
endif()
if(ZINT_STATIC)
    install(TARGETS zint-static EXPORT zint-targets ${INSTALL_TARGETS_DEFAULT_ARGS})
endif()
install(EXPORT zint-targets NAMESPACE zint:: DESTINATION "${CMAKE_INSTALL_DATADIR}/zint")
install(FILES zint.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR} COMPONENT Devel)

if(ZINT_TEST)
    add_subdirectory(tests)
endif()

=== frontend/CMakeLists.txt ===
# Copyright (C) 2008 by BogDan Vatra < bogdan@licentia.eu >
# Copyright (C) 2009-2024 Robin Stuart <rstuart114@gmail.com>
# vim: set ts=4 sw=4 et :

cmake_minimum_required(VERSION 3.10)
project(zint_frontend)

add_executable(${PROJECT_NAME} main.c)

if(WIN32)
    target_sources(${PROJECT_NAME} PRIVATE zint.rc)
endif()

target_include_directories(${PROJECT_NAME} PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/../backend")

set_target_properties(${PROJECT_NAME} PROPERTIES OUTPUT_NAME "zint")

if(ZINT_SHARED)
    target_link_libraries(${PROJECT_NAME} zint)
else()
    target_link_libraries(${PROJECT_NAME} zint-static)
endif()
if(NOT HAVE_GETOPT_LONG_ONLY)
    target_link_libraries(${PROJECT_NAME} zint_bundled_getopt)
endif()

install(TARGETS ${PROJECT_NAME} DESTINATION "${CMAKE_INSTALL_BINDIR}" RUNTIME)
if(UNIX)
    install(FILES "${CMAKE_CURRENT_SOURCE_DIR}/../docs/zint.1" DESTINATION "${CMAKE_INSTALL_MANDIR}/man1" COMPONENT doc)
endif()

if(ZINT_TEST)
    add_subdirectory(tests)
endif()

=== frontend_qt/CMakeLists.txt ===
# Copyright (C) 2008 by BogDan Vatra < bogdan@licentia.eu >
# Copyright (C) 2009-2024 Robin Stuart <rstuart114@gmail.com>
# SPDX-License-Identifier: GPL-3.0-or-later
# vim: set ts=4 sw=4 et :

cmake_minimum_required(VERSION 3.10)
project(zint-qt)

set(CMAKE_AUTORCC ON)

set(${PROJECT_NAME}_SRCS barcodeitem.cpp main.cpp mainwindow.cpp
                            cliwindow.cpp datawindow.cpp scalewindow.cpp sequencewindow.cpp exportwindow.cpp)

if(USE_QT6)
    qt6_wrap_cpp(zint-qt_SRCS mainwindow.h cliwindow.h datawindow.h scalewindow.h sequencewindow.h exportwindow.h)
    qt6_wrap_ui(zint-qt_SRCS mainWindow.ui extCLI.ui extData.ui extScale.ui extSequence.ui extExport.ui)
else()
    qt5_wrap_cpp(zint-qt_SRCS mainwindow.h cliwindow.h datawindow.h scalewindow.h sequencewindow.h exportwindow.h)
    qt5_wrap_ui(zint-qt_SRCS mainWindow.ui extCLI.ui extData.ui extScale.ui extSequence.ui extExport.ui)
endif()

#           grpAztec.ui  grpC39.ui      grpCodablockF.ui  grpDotCode.ui  grpMailmark2D.ui  grpPDF417.ui   grpUltra.ui
#           grpC11.ui    grpC49.ui      grpCodeOne.ui     grpDPD.ui      grpMaxicode.ui    grpPlessey.ui  grpUPCA.ui
#           grpC128.ui   grpC93.ui      grpDAFT.ui        grpGrid.ui     grpMicroPDF.ui    grpPZN.ui      grpUPCEAN.ui
#           grpC16k.ui   grpChannel.ui  grpDBExtend.ui    grpHX.ui       grpMQR.ui         grpQR.ui       grpUPNQR.ui
#           grpC25.ui    grpCodabar.ui  grpDM.ui          grpITF14.ui    grpMSICheck.ui    grpRMQR.ui     grpVIN.ui

if(APPLE)
    # https://doc.qt.io/qt-5/appicon.html
    set(MACOSX_BUNDLE_ICON_FILE zint-qt.icns)
    set(APP_ICON_MACOSX "${CMAKE_CURRENT_SOURCE_DIR}/zint-qt.icns")
    set_source_files_properties(${APP_ICON_MACOSX} PROPERTIES MACOSX_PACKAGE_LOCATION "Resources")
    add_executable(${PROJECT_NAME} MACOSX_BUNDLE ${zint-qt_SRCS} resources.qrc ${APP_ICON_MACOSX})
    set_target_properties(${PROJECT_NAME} PROPERTIES
        MACOSX_BUNDLE TRUE
        MACOSX_BUNDLE_BUNDLE_NAME "Zint Barcode Studio"
        MACOSX_BUNDLE_BUNDLE_VERSION ${ZINT_VERSION}
        MACOSX_BUNDLE_COPYRIGHT "Copyright © 2006-2022 Robin Stuart and others"
        MACOSX_BUNDLE_GUI_IDENTIFIER "uk.org.zint.zint-qt"
        MACOSX_BUNDLE_INFO_STRING "A free barcode generator"
        MACOSX_BUNDLE_SHORT_VERSION_STRING ${ZINT_VERSION})
else()
    add_executable(${PROJECT_NAME} ${zint-qt_SRCS} resources.qrc)
endif()

if(WIN32)
    target_sources(${PROJECT_NAME} PRIVATE res/qtZint.rc)
endif()

target_include_directories(${PROJECT_NAME} PUBLIC "${CMAKE_CURRENT_SOURCE_DIR}/../backend" "${CMAKE_CURRENT_SOURCE_DIR}/../backend_qt")

if(ZINT_SHARED)
    target_link_libraries(${PROJECT_NAME} zint)
else()
    target_link_libraries(${PROJECT_NAME} zint-static)
endif()
target_link_libraries(${PROJECT_NAME} QZint
                        Qt${QT_VERSION_MAJOR}::UiTools Qt${QT_VERSION_MAJOR}::Gui Qt${QT_VERSION_MAJOR}::Svg
                        Qt${QT_VERSION_MAJOR}::Core)


install(TARGETS ${PROJECT_NAME} DESTINATION "${CMAKE_INSTALL_BINDIR}" RUNTIME)

=== backend/tests/CMakeLists.txt ===
# Copyright (C) 2009-2025 Robin Stuart <rstuart114@gmail.com>
# Adapted from qrencode/tests/CMakeLists.txt
# Copyright (C) 2006-2017 Kentaro Fukuchi <kentaro@fukuchi.org>
# vim: set ts=4 sw=4 et :

cmake_minimum_required(VERSION 3.10)
project(zint_backend_tests)

enable_testing()

include(${zint-package_SOURCE_DIR}/cmake/zint_add_test.cmake)

set(BWIPP_TAR ${CMAKE_CURRENT_SOURCE_DIR}/tools/bwipp_dump.ps.tar.xz)
set(BWIPP_PS ${CMAKE_CURRENT_BINARY_DIR}/tools/bwipp_dump.ps)

if(NOT EXISTS ${BWIPP_PS})
    file(MAKE_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/tools)
    execute_process(COMMAND ${CMAKE_COMMAND} -E tar -xf ${BWIPP_TAR}
                    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/tools)
endif()

set(testcommon_SRCS testcommon.c testcommon.h)

if(ZINT_SHARED)
    add_library(testcommon ${testcommon_SRCS})
    target_link_libraries(testcommon zint)
    target_include_directories(testcommon PUBLIC ${zint_backend_tests_SOURCE_DIR})
    if(NOT (ZINT_USE_PNG AND PNG_FOUND))
        target_compile_definitions(testcommon PRIVATE ZINT_NO_PNG)
    endif()
endif()

if(ZINT_STATIC)
    add_library(testcommon-static ${testcommon_SRCS})
    target_link_libraries(testcommon-static zint-static)
    target_include_directories(testcommon-static PUBLIC ${zint_backend_tests_SOURCE_DIR})
    if(NOT (ZINT_USE_PNG AND PNG_FOUND))
        target_compile_definitions(testcommon-static PRIVATE ZINT_NO_PNG)
    endif()
endif()

zint_add_test(2of5 test_2of5)
zint_add_test(auspost test_auspost)
zint_add_test(aztec test_aztec)
zint_add_test(bc412 test_bc412)
zint_add_test(big5 test_big5)
zint_add_test(bmp test_bmp)
zint_add_test(channel test_channel)
zint_add_test(codabar test_codabar)
zint_add_test(codablock test_codablock)
zint_add_test(code test_code)
zint_add_test(code1 test_code1)
zint_add_test(code11 test_code11)
zint_add_test(code128 test_code128)
zint_add_test(code16k test_code16k)
zint_add_test(code49 test_code49)
zint_add_test(common test_common)
zint_add_test(composite test_composite)
zint_add_test(dmatrix test_dmatrix)
zint_add_test(dotcode test_dotcode)
zint_add_test(dxfilmedge test_dxfilmedge)
zint_add_test(eci test_eci)
zint_add_test(emf test_emf)
zint_add_test(filemem test_filemem)
zint_add_test(gb18030 test_gb18030)
zint_add_test(gb2312 test_gb2312)
zint_add_test(gif test_gif)
zint_add_test(gridmtx test_gridmtx)
zint_add_test(gs1 test_gs1)
zint_add_test(hanxin test_hanxin)
zint_add_test(imail test_imail)
zint_add_test(iso3166 test_iso3166)
zint_add_test(iso4217 test_iso4217)
zint_add_test(ksx1001 test_ksx1001)
zint_add_test(large test_large)
zint_add_test(library test_library)
zint_add_test(mailmark test_mailmark)
zint_add_test(maxicode test_maxicode)
zint_add_test(medical test_medical)
zint_add_test(output test_output)
zint_add_test(pcx test_pcx)
zint_add_test(pdf417 test_pdf417)
zint_add_test(plessey test_plessey)
if(ZINT_USE_PNG AND PNG_FOUND)
zint_add_test(png test_png)
endif()
zint_add_test(postal test_postal)
zint_add_test(print test_print)
zint_add_test(ps test_ps)
zint_add_test(qr test_qr)
zint_add_test(raster test_raster)
zint_add_test(reedsol test_reedsol)
zint_add_test(rss test_rss)
zint_add_test(sjis test_sjis)
zint_add_test(svg test_svg)
zint_add_test(telepen test_telepen)
zint_add_test(tif test_tif)
zint_add_test(ultra test_ultra)
zint_add_test(upcean test_upcean)
zint_add_test(vector test_vector)

=== backend_qt/tests/CMakeLists.txt ===
# Copyright (C) 2021-24 Robin Stuart <rstuart114@gmail.com>
# vim: set ts=4 sw=4 et :

cmake_minimum_required(VERSION 3.10)
project(QZint_tests LANGUAGES CXX)

enable_testing()

if(USE_QT6)
    find_package(Qt6Test REQUIRED)
else()
    find_package(Qt5Test REQUIRED)
endif()

set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_AUTOMOC ON)

add_executable(test_qzint test_qzint.cpp)
target_link_libraries(test_qzint PRIVATE QZint Qt${QT_VERSION_MAJOR}::Test)
add_test(NAME qzint COMMAND test_qzint)
if(MSVC)
    set_tests_properties(qzint PROPERTIES ENVIRONMENT
        "PATH=${CMAKE_BINARY_DIR}/backend/${CMAKE_BUILD_TYPE}\;${CMAKE_BINARY_DIR}/frontend/${CMAKE_BUILD_TYPE}\;$ENV{PATH}")
else()
    set_tests_properties(qzint PROPERTIES ENVIRONMENT
        "LD_LIBRARY_PATH=${CMAKE_BINARY_DIR}/backend;PATH=${CMAKE_BINARY_DIR}/frontend:$ENV{PATH}")
endif()

=== debian/changelog ===
zint (2.15.0-1) unstable; urgency=medium

  * New upstream release.
    + Install library files under multiarch location (Closes: #1060878).
  * Set libzint2.15 package as "Multi-Arch: same".

 -- Dmitry Smirnov <onlyjob@debian.org>  Fri, 28 Feb 2025 22:50:03 +1100

=== debian/control ===
Source: zint
Section: graphics
Priority: optional
Maintainer: Dmitry Smirnov <onlyjob@debian.org>
Uploaders: Jakob Haufe <sur5r@debian.org>
Build-Depends: debhelper-compat (= 12)
    ,cmake
    ,libpng-dev
    ,libqt5svg5-dev
    ,pandoc
    ,qtbase5-dev
    ,qttools5-dev
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/debian/zint
Vcs-Git: https://salsa.debian.org/debian/zint.git
Homepage: https://zint.org.uk/
Rules-Requires-Root: no

Package: zint
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: command line utility to encode data in barcode symbols
 Zint is a barcode encoding and image generating library. It currently
 features support for over 50 symbologies including Australian Post
 4-state codes (redirect, reply-paid, routing, standard customer),
 Aztec Code (ISO 24778), Aztec Runes, Channel code, Codabar, Code 11,
 Code 128 (ISO 15417), Code 16k, Code 2 of 5 (Data Logic, IATA,
 Industrial, Interleaved, Matrix), Code 32 (Italian Pharmacode), Code
 39 (ISO 16388), Code 39 Extended, Code 49, Code 93, Code One, Databar
 (Expanded, Expanded Stacked, Limited, Stacked Omnidirectional), Data
 Matrix (ISO 16022), Deutsche Post (Identicode, Leitcode), Dutch Post
 KIX, EAN-14, European Article Number (EAN), Facing Identification
 Mark (FIM), Flattermarken, Grid Matrix, ITF-14, International Standard
 Book Number (ISBN), Japanese Postal Barcode, Korean Postal Barcode,
 LOGMARS, Maxicode (ISO 16023), MicroPDF417 (ISO 24728), Micro QR
 Code, MSI Plessey, NVE-18, PDF417 (ISO 15438), Pharmacode (2-track,
 Zentralnummer (PZN)), PLANET, Postnet, QR Code (ISO 18004), Royal
 Mail 4-state Barcode, Telepen, Telepen Numeric, UK Plessey, Universal
 Product Code (UPC-A, UPC-E), USPS Intelligent Mail as well as HIBC.
 .
 Also included are Unicode translation for symbologies which support
 Latin-1 and Kanji character sets, full GS1 data support including
 verification and automated insertion of FNC1 characters and support for
 encoding binary data including NULL (ASCII 0) characters.
 .
 This package contains Zint Barcode Generator (command-line utility).

Package: zint-qt
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Zint Barcode Studio, a QT frontend to zint
 Zint is a barcode encoding and image generating library. It currently
 features support for over 50 symbologies including Australian Post
 4-state codes (redirect, reply-paid, routing, standard customer),
 Aztec Code (ISO 24778), Aztec Runes, Channel code, Codabar, Code 11,
 Code 128 (ISO 15417), Code 16k, Code 2 of 5 (Data Logic, IATA,
 Industrial, Interleaved, Matrix), Code 32 (Italian Pharmacode), Code
 39 (ISO 16388), Code 39 Extended, Code 49, Code 93, Code One, Databar
 (Expanded, Expanded Stacked, Limited, Stacked Omnidirectional), Data
 Matrix (ISO 16022), Deutsche Post (Identicode, Leitcode), Dutch Post
 KIX, EAN-14, European Article Number (EAN), Facing Identification
 Mark (FIM), Flattermarken, Grid Matrix, ITF-14, International Standard
 Book Number (ISBN), Japanese Postal Barcode, Korean Postal Barcode,
 LOGMARS, Maxicode (ISO 16023), MicroPDF417 (ISO 24728), Micro QR
 Code, MSI Plessey, NVE-18, PDF417 (ISO 15438), Pharmacode (2-track,
 Zentralnummer (PZN)), PLANET, Postnet, QR Code (ISO 18004), Royal
 Mail 4-state Barcode, Telepen, Telepen Numeric, UK Plessey, Universal
 Product Code (UPC-A, UPC-E), USPS Intelligent Mail as well as HIBC.
 .
 Also included are Unicode translation for symbologies which support
 Latin-1 and Kanji character sets, full GS1 data support including
 verification and automated insertion of FNC1 characters and support for
 encoding binary data including NULL (ASCII 0) characters.
 .
 This package contains Zint Barcode Studio, a QT frontend for the Zint
 barcode encoding library.

Package: libzint2.15
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: library for encoding data in barcode symbols
 Zint is a barcode encoding and image generating library. It currently
 features support for over 50 symbologies including Australian Post
 4-state codes (redirect, reply-paid, routing, standard customer),
 Aztec Code (ISO 24778), Aztec Runes, Channel code, Codabar, Code 11,
 Code 128 (ISO 15417), Code 16k, Code 2 of 5 (Data Logic, IATA,
 Industrial, Interleaved, Matrix), Code 32 (Italian Pharmacode), Code
 39 (ISO 16388), Code 39 Extended, Code 49, Code 93, Code One, Databar
 (Expanded, Expanded Stacked, Limited, Stacked Omnidirectional), Data
 Matrix (ISO 16022), Deutsche Post (Identicode, Leitcode), Dutch Post
 KIX, EAN-14, European Article Number (EAN), Facing Identification
 Mark (FIM), Flattermarken, Grid Matrix, ITF-14, International Standard
 Book Number (ISBN), Japanese Postal Barcode, Korean Postal Barcode,
 LOGMARS, Maxicode (ISO 16023), MicroPDF417 (ISO 24728), Micro QR
 Code, MSI Plessey, NVE-18, PDF417 (ISO 15438), Pharmacode (2-track,
 Zentralnummer (PZN)), PLANET, Postnet, QR Code (ISO 18004), Royal
 Mail 4-state Barcode, Telepen, Telepen Numeric, UK Plessey, Universal
 Product Code (UPC-A, UPC-E), USPS Intelligent Mail as well as HIBC.
 .
 Also included are Unicode translation for symbologies which support
 Latin-1 and Kanji character sets, full GS1 data support including
 verification and automated insertion of FNC1 characters and support for
 encoding binary data including NULL (ASCII 0) characters.
 .
 This package provides barcode generator library.

Package: libzint-dev
Section: libdevel
Architecture: any
Depends: libzint2.15 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Zint development files
 Zint is a barcode encoding and image generating library. It currently
 features support for over 50 symbologies including Australian Post
 4-state codes (redirect, reply-paid, routing, standard customer),
 Aztec Code (ISO 24778), Aztec Runes, Channel code, Codabar, Code 11,
 Code 128 (ISO 15417), Code 16k, Code 2 of 5 (Data Logic, IATA,
 Industrial, Interleaved, Matrix), Code 32 (Italian Pharmacode), Code
 39 (ISO 16388), Code 39 Extended, Code 49, Code 93, Code One, Databar
 (Expanded, Expanded Stacked, Limited, Stacked Omnidirectional), Data
 Matrix (ISO 16022), Deutsche Post (Identicode, Leitcode), Dutch Post
 KIX, EAN-14, European Article Number (EAN), Facing Identification
 Mark (FIM), Flattermarken, Grid Matrix, ITF-14, International Standard
 Book Number (ISBN), Japanese Postal Barcode, Korean Postal Barcode,
 LOGMARS, Maxicode (ISO 16023), MicroPDF417 (ISO 24728), Micro QR
 Code, MSI Plessey, NVE-18, PDF417 (ISO 15438), Pharmacode (2-track,
 Zentralnummer (PZN)), PLANET, Postnet, QR Code (ISO 18004), Royal
 Mail 4-state Barcode, Telepen, Telepen Numeric, UK Plessey, Universal
 Product Code (UPC-A, UPC-E), USPS Intelligent Mail as well as HIBC.
 .
 Also included are Unicode translation for symbologies which support
 Latin-1 and Kanji character sets, full GS1 data support including
 verification and automated insertion of FNC1 characters and support for
 encoding binary data including NULL (ASCII 0) characters.
 .
 This package contains development files for the Zint barcode encoding
 library and for the Qt wrapper over the Zint library.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --buildsystem=cmake

override_dh_clean:
	dh_clean
	chmod -x *.png *.desktop

#override_dh_makeshlibs:
#	dh_makeshlibs -V

execute_before_dh_auto_build:
	$(MAKE) -C docs zint.1

=== debian/watch ===
version=3

## http://qa.debian.org/watch/sf.php/zint

https://sf.net/zint/zint-(\d[-\d.]+)(?:[\.-]src)?\.tar\.(?:gz|bz2|xz)
